<template>
<div>
  <ul class="nav p-3">
    <li class="nav-item">

      <div class="dropdown">
        <button class="btn btn-info dropdown-toggle" role="button" id="dropdownMenuLink" data-bs-toggle="dropdown" aria-expanded="false">
          Nadzorujący
        </button>

        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink">
          <li v-for="sv in supervisors_list" :key="sv.id">
            <input class="form-check-input" type="checkbox" v-model="sv.checkbox" v-bind:value="sv.id" id="flexCheckDefault" @change="(event) => SelectFilter(event, supervisors_selected_ids)">
            <label class="form-check-label" for="flexCheckDefault">
              {{sv.name.first_name}} {{sv.name.last_name}}
            </label>
           </li>
        </ul>
      </div>

    </li>

    <li class="nav-item" v-if="user_type == 'SquadronCommander' || user_type == 'KeyCommander'">
      <div class="dropdown">
        <button class="btn btn-info dropdown-toggle" role="button" id="dropdownMenuLink" data-bs-toggle="dropdown" aria-expanded="false">
          Wykonawcy
        </button>

        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink">
          <li v-for="exec in executors_list" :key="exec.id">
            <input class="form-check-input" type="checkbox" v-model="exec.checkbox" v-bind:value="exec.id" id="flexCheckDefault" @change="(event) => SelectFilter(event, executors_selected_ids)">
            <label class="form-check-label" for="flexCheckDefault">
              {{exec.name.first_name}} {{exec.name.last_name}}
            </label>
           </li>
        </ul>
      </div>
    </li>

    <li class="nav-item">

      <div class="dropdown">
        <button class="btn btn-info dropdown-toggle" role="button" id="dropdownMenuLink" data-bs-toggle="dropdown" aria-expanded="false">
          Specjalizacja
        </button>

        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink">
          <li v-for="spec in spec_list" :key="spec.id">
            <input class="form-check-input" type="checkbox" v-model="spec.checkbox" v-bind:value="spec.id" id="flexCheckDefault" @change="(event) => SelectFilter(event, spec_selected_ids)">
            <label class="form-check-label" for="flexCheckDefault">
              {{spec.name}}
            </label>
           </li>
        </ul>
      </div>

    </li>

    <li class="nav-item px-1" v-if="user_type == 'SquadronCommander' || user_type == 'KeyCommander'">
      <input class="btn-check" type="checkbox" id="btn-check-2-outlined" v-model="with_completed">
      <label class="btn btn-outline-success" for="btn-check-2-outlined">
        pokaż zakończone
      </label>
    </li>

    <li class="nav-item px-1">
      <button class="btn btn-dark" type="button" @click=ApplyFilters>
        Filtruj
      </button>
    </li>

    <li class="nav-item">
      <button class="btn btn-secondary" type="button" @click=ClearFilters>
        Wyczyść filtry
      </button>
    </li>

    <li v-if="user_type == 'SquadronCommander' || user_type == 'KeyCommander'" class="nav-item px-3">
      <button class="btn btn-primary" type="button" @click=on_add_new>Dodaj</button>
    </li>
  </ul>

  <table class="table">
    <thead>
      <tr>
        <!-- @TODO change id Nagłówka to number Nagłówka -->
        <th scope="col">numer Nagłówka</th>
        <th scope="col">estymowane roboczogodziny</th>
        <th scope="col">rzeczywiste roboczogodziny</th>
        <th scope="col">data zakończenia</th>
        <th scope="col">specjalizacja</th>
        <th scope="col">nadzorujący</th>
        <th scope="col">wykonawcy</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="card in card_handlings_list" :key="card.id">
        <th scope="row">{{card.header_number}}</th>
        <td>{{card.effort_hours}}</td>
        <td>{{card.man_hours}}</td>
        <td>{{card.finish_date}}</td>
        <td>{{card.specialization}}</td>
        <td>{{card.supervisier_partial_serialized.name.first_name}} {{card.supervisier_partial_serialized.name.last_name}} </td>
        <td>
          <span v-for="execute in card.execute_set" :key="execute.id">
            <span :style="execute.state ? {'color': 'green'} : {'color': 'red'}">
              {{execute.executor_partial_serialized.name.first_name}}
              {{execute.executor_partial_serialized.name.last_name}}
            </span>
          <br/>
          </span>
        </td>
        <td><RouterLink :to="'/jzot/' + card.jzot">jzot</RouterLink></td>
        <td>
          <div class="btn-group" v-if="canModify(card.supervisier_partial_serialized.id)">
            <button class="btn btn-secondary" @click="EditCardHandling(card.id)">Edytuj</button>
            <button class="btn btn-secondary" @click="DeleteCardHandling(card.id)">Usuń</button>
          </div>

          <button
            class="btn btn-secondary" v-else-if="user_type == 'Executor'" @click="ExecutorCompleteHandling(card.execute_set)">
              Potwierdź Wykonanie
            </button>
        </td>
      </tr>
    </tbody>
  </table>
</div>

</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { getCardHandlings, deleteDataBaseObject, getSupervisorsPartial,
         getExecutorsPartial, getSpecializations, completeExecute
        } from "../../utils/apiUtils";
import router from "../../router";

const card_handlings_url = "http://127.0.0.1:8000/handlings/card_handlings/";

export default {
  name: "CardHandlingBrowse",
  props: {
    header_id : String,
    user_type : String,
    on_edit : Function,
    on_add_new : Function
  },
  data: function() {
    return {
      card_handlings_list: [],
      supervisors_list: [],
      executors_list: [],
      spec_list: [],

      with_completed: false,
      supervisors_selected_ids: new Set(),
      executors_selected_ids: new Set(),
      spec_selected_ids: new Set()
    };
  },
  methods: {
    ApplyFilters() {
      (async () => {
          const params = {
            filters: {
              header_id: this.header_id,
              with_completed: this.with_completed,
              supervisor: JSON.stringify(Array.from(this.supervisors_selected_ids.values())),
              executor: JSON.stringify(Array.from(this.executors_selected_ids.values())),
              specialization: JSON.stringify(Array.from(this.spec_selected_ids.values())),
            }
          }

          console.log("filters: ", params);
          setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
          this.card_handlings_list = await getCardHandlings(params);
      })();
    },
    ClearFilters() {
      for (let spec of this.supervisors_list) {
        spec.checkbox = false
      }
      for (let type of this.executors_list) {
        type.checkbox = false
      }
      for (let type of this.spec_list) {
        type.checkbox = false
      }

      this.with_completed = false,
      this.supervisors_selected_ids.clear()
      this.executors_selected_ids.clear()
      this.spec_selected_ids.clear()
    },
    SelectFilter(event, selected_set) {
      if (event.target.checked) {
        selected_set.add(parseInt(event.target.value, 10))
      } else {
        selected_set.delete(parseInt(event.target.value, 10))
      }
    },
    EditCardHandling(id) {
      this?.on_edit(id)
    },
    DeleteCardHandling(id) {
      if (window.confirm("Are you sure ?")) {
        (async () => {
          try {
              setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
              const response = await deleteDataBaseObject(card_handlings_url + id + "/");
              if (response.status === 204) {
                  window.alert("card handling deleted");
                  this.ApplyFilters();
              }
          } catch (error) {
              window.alert("cannot delete this card handling type");
          }
      })();
      }
    },
    ExecutorCompleteHandling(execute_set) {
      let executes = execute_set.filter(
        execute => execute.executor_partial_serialized.id == this.$store.state.user.extended_user.id
        );

      (async () => {
        for (const execute of executes) {
          await completeExecute(execute.id, {state: true});
        }
        this.ApplyFilters();
      })();
    },
    canModify(owner_id) {
      return this.user_type == 'SquadronCommander' ||
        (this.user_type == 'KeyCommander' && owner_id == this.$store.state.user.extended_user.id)
    }
  },
  computed: {
    isAuthenticated: function() {
      return this.$store.state.isAuthenticated
    }
  },
  mounted: function() {
    (async () => {
        const params = {
          filters: {
            header_id: this.header_id,
            with_completed: false,
          }
        }
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        // @TODO edit only for staff
        this.card_handlings_list = await getCardHandlings(params);

        this.supervisors_list = await getSupervisorsPartial();
        this.executors_list = await getExecutorsPartial();
        this.spec_list = await getSpecializations();
    })();
  }
};
</script>

<style scoped>
/* @TODO do something with this styles!!! - make it global or something */
</style>>